<?php
/*
Plugin Name: Persian WordPress
Plugin URI: http://wordpress.org/extend/plugins/persian-world/
Description: Experience the Awesome Persian World with Persian WordPress. 
Version: 2.7
Author: Danial Hatami
Author URI: http://adurl.ir
*/


/*  Copyright 2010-2013  Danial Hatami (email : Great.emperor94@gmail.com)

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

*/


/* Memory Limit */
function pwmb() {
	if ( current_user_can( 'manage_options' ) )
		@ini_set( 'memory_limit', '256M' );
}
add_action( 'admin_init', 'pwmb' );

/* RTL WP */
$text_direction = "rtl";

/* Get Trans. file */
function wif_get_localization_code() {
	return fa_IR;
}
add_filter('locale', 'wif_get_localization_code');

function wif_load_default_textdomain() {
	$locale = get_locale();
	$plugin_base = dirname(__FILE__);
	$mofile = $plugin_base . "/$locale.mo";
	return load_textdomain('default', $mofile);
}
	add_action('plugins_loaded','wif_load_default_textdomain');
	
function wif_load_default_textadminnetwork() {
	$locale = get_locale();
	$msplugin_base = dirname(__FILE__);
	$msfile = $msplugin_base . "/admin-network-$locale.mo";
	return load_textdomain('default', $msfile);
}
	add_action('plugins_loaded','wif_load_default_textadminnetwork');

function bbpress_init() {
  load_plugin_textdomain( 'bbpress', false, dirname( plugin_basename( __FILE__ ) ) ); 
}
add_action('plugins_loaded', 'bbpress_init');

function buddypress_init() {
  load_plugin_textdomain( 'buddypress', false, dirname( plugin_basename( __FILE__ ) ) ); 
}
add_action('plugins_loaded', 'buddypress_init');
	
function wif_load_default_textadmin() {
	$adplugin_base = dirname(__FILE__);
	$adfile = $adplugin_base . "/admin-fa_IR.mo";
	return load_textdomain('default', $adfile);
}
	add_action('plugins_loaded','wif_load_default_textadmin');

/* Utf-8 M-Conversion */	

class standard_Utf8_Exception extends Exception
{}

class standard_Utf8
{
    /**
     * Escape Utf-8 characters using the given options
     */
    public static function escape($value, array $options = array())
    {
        $options = array_merge(array(
            'escapeControlChars'   => true,
            'escapePrintableASCII' => false,
            'write'                => array(
                'callback'  => 'sprintf',
                'arguments' => array('\u%04x'),
            ),
            'extendedUseSurrogate' => true,
        ), $options);
        if (! self::isCallable($options['write']))
        {
            throw new standard_Utf8_Exception('Expected a valid write handler (callable, array).');
        }
        if (self::validateFilters($options) && isset($options['filters']['before-write']))
        {
            $value = self::call($options['filters']['before-write'], $value);
        }
        
        $result = "";
        $length = strlen($value);
        for($i = 0; $i < $length; $i++) {
            $ord_var_c = ord($value[$i]);
            
            switch (true) {
                case ($ord_var_c < 0x20):
                    // code points 0x00000000..0x0000001F, mask 0xxxxxxx
                    $utf8Char = $value[$i];
                    $result .= $options['escapeControlChars']
                        ? self::call($options['write'], array($ord_var_c, $utf8Char))
                        : $value[$i];
                break;

                case ($ord_var_c < 0x80):
                    // code points 0x00000020..0x0000007F, mask 0xxxxxxx
                    $utf8Char = $value[$i];
                    $result .= $options['escapePrintableASCII'] 
                        ? self::call($options['write'], array($ord_var_c, $utf8Char))
                        : $value[$i];
                break;

                case (($ord_var_c & 0xE0) == 0xC0):
                    
                    $utf8Char = substr($value, $i, 2); $i += 1;
                    $code = self::utf8CharToCodePoint($utf8Char);
                    $result .= self::call($options['write'], array($code, $utf8Char));
                break;

                case (($ord_var_c & 0xF0) == 0xE0):
                    
                    $utf8Char = substr($value, $i, 3); $i += 2;
                    $code = self::utf8CharToCodePoint($utf8Char);
                    $result .= self::call($options['write'], array($code, $utf8Char));
                break;

                case (($ord_var_c & 0xF8) == 0xF0):
                    
                    $utf8Char = substr($value, $i, 4); $i += 3;
                    if ($options['extendedUseSurrogate'])
                    {
                        list($upper, $lower) = self::utf8CharToSurrogatePair($utf8Char);
                        $result .= self::call($options['write'], array($upper, $utf8Char));
                        $result .= self::call($options['write'], array($lower, $utf8Char));
                    }
                    else 
                    {
                        $code = self::utf8CharToCodePoint($utf8Char);
                        $result .= self::call($options['write'], array($code, $utf8Char));
                    }
                break;

                default:
                    
                    throw new standard_Utf8_Exception('Expected a valid UTF-8 character.');
                break;
            }
        }

        return $result;
     }
     
    public static function utf8CharToCodePoint($utf8Char)
    {
        if (function_exists('mb_convert_encoding')) 
        {
            $utf32Char = mb_convert_encoding($utf8Char, 'UTF-32', 'UTF-8');
        } 
        else 
        {
            $bytes = array('C*');
            list(, $utf8Int) = unpack('N', str_repeat(chr(0), 4 - strlen($utf8Char)) . $utf8Char);
            switch (strlen($utf8Char)) 
            {
                case 1:

                    $bytes[] = 0;
                    $bytes[] = 0;
                    $bytes[] = 0;
                    $bytes[] = $utf8Int;
                break;
    
                case 2:
                    $bytes[] = 0;
                    $bytes[] = 0;
                    $bytes[] = $utf8Int >> 10 & 0x07;
                    $bytes[] = $utf8Int >>  2 & 0xC0 | $utf8Int       & 0x3F;
                break;
    
                case 3:
                    $bytes[] = 0;
                    $bytes[] = 0;
                    $bytes[] = $utf8Int >> 12 & 0xF0 | $utf8Int >> 10 & 0x0F;
                    $bytes[] = $utf8Int >>  2 & 0xC0 | $utf8Int       & 0x3F;
                break;
                             
                case 4:
                    $bytes[] = 0;
                    $bytes[] = $utf8Int >> 22 & 0x1C | $utf8Int >> 20 & 0x03;
                    $bytes[] = $utf8Int >> 12 & 0xF0 | $utf8Int >> 10 & 0x0F;
                    $bytes[] = $utf8Int >>  2 & 0xC0 | $utf8Int       & 0x3F;
                break;
                
                default:

                    throw new standard_Utf8_Exception('Expected a valid UTF-8 character.');
                break;
            }
            $utf32Char = call_user_func_array('pack', $bytes);
        }
        list(, $result) = unpack('N', $utf32Char); //unpack returns an array with base 1
        if (0xD800 <= $result && $result <= 0xDFFF) 
        {
            //reserved for UTF-16 surrogates
            throw new standard_Utf8_Exception('Expected a valid UTF-8 character.');
        }
        if (0xFFFE == $result || 0xFFFF == $result) 
        {
            //reserved
            throw new standard_Utf8_Exception('Expected a valid UTF-8 character.');
        }
        
        return $result;
    }
    
    public static function utf8CharToSurrogatePair($utf8Char) 
    {
        $codePoint = self::utf8CharToCodePoint($utf8Char);
        if ($codePoint < 0x10000) 
        {
            throw new standard_Utf8_Exception('Expected an extended UTF-8 character.');
        }
        $codePoint -= 0x10000;
        $upperSurrogate = 0xD800 + ($codePoint >> 10);
        $lowerSurrogate = 0xDC00 + ($codePoint & 0x03FF);
        $result = array($upperSurrogate, $lowerSurrogate);
        
        return $result;
    }
    
	// Unescape UTF-8 characters from a given escape format
     // return string
    public static function unescape($value, array $options = array())
    {
        $options = array_merge(array(
        	'read'                 => array(
            	'pattern'   => '\\\\u([0-9A-Fa-f]{4})',
                'callback'  => create_function('$all, $code', 'return hexdec($code);'),
                'arguments' => array(),
            ),
            'extendedUseSurrogate' => true,
        ), $options);
        if (! self::isCallable($options['read']))
        {
            throw new standard_Utf8_Exception('Expected a valid read handler (callable, array).');
        }
        $thereAreFilters = self::validateFilters($options);
        
        $result = "";
        $length = strlen($value);
        $pattern = '@([\w\W]*?)(' . $options['read']['pattern'] . ')|([\w\W]+)@';
        $offset = 0;
        while (preg_match($pattern, $value, $matches, 0, $offset))
        {
            if (! $matches[2])
            {
                //no more escape patterns
                $result .= $matches[0];
                $offset += strlen($matches[0]);
            }
            else 
            {
                //one more escape pattern
                $result .= $matches[1];
                $offset += strlen($matches[0]);
                $args = array_splice($matches, 2, count($matches) - 1);
                $unicode = self::call($options['read'], $args);//                call_user_func($options['integer'], $matches[2]);
                if ($options['extendedUseSurrogate'] && (0xD800 <= $unicode && $unicode < 0xDC00))
                {
                    $upperSurrogate = $unicode;
                    preg_match($pattern, $value, $matches, 0, $offset);
                    if (! $matches[2])
                    {
                        throw new standard_Utf8_Exception('Expected an extended UTF-8 character.');
                    }
                    $offset += strlen($matches[0]);
                    $args = array_splice($matches, 2, count($matches) - 1);
                    $unicode = self::call($options['read'], $args);//$lowerSurrogate = call_user_func($options['integer'], $matches[2]);
                    $utf8Char = self::utf8CharFromSurrogatePair(array($upperSurrogate, $unicode));
                }
                else 
                {
                    $utf8Char = self::utf8CharFromCodePoint($unicode);
                }
                $result .= $utf8Char;
            }
        }
        if ($thereAreFilters && isset($options['filters']['after-read']))
        {
            $result = self::call($options['filters']['after-read'], $result);
        }
        
        return $result;
     }
     

     // Compute the UTF-8 character of a given code point

    public static function utf8CharFromCodePoint($codePoint)
    {
        if (0xD800 <= $codePoint && $codePoint <= 0xDFFF) 
        {
            //reserved for UTF-16 surrogates
            throw new standard_Utf8_Exception('Expected a valid code point.');
        }
        if (0xFFFE == $codePoint || 0xFFFF == $codePoint) 
        {
            //reserved
            throw new standard_Utf8_Exception('Expected a valid code point.');
        }
        
        if (function_exists('mb_convert_encoding')) 
        {
            $utf32Char = pack('N', $codePoint);
            $result = mb_convert_encoding($utf32Char, 'UTF-8', 'UTF-32');
        } 
        else 
        {
            $bytes = array('C*');
            switch (true)
            {
                case ($codePoint < 0x80):

                    $bytes[] = $codePoint;
                break;
                
                case ($codePoint < 0x800):

                    $bytes[] = 0xC0 | $codePoint >> 6;
                    $bytes[] = 0x80 | $codePoint       & 0x3F;
                break;
                
                case ($codePoint < 0x10000):

                    $bytes[] = 0xE0 | $codePoint >> 12;
                    $bytes[] = 0x80 | $codePoint >> 6  & 0x3F;
                    $bytes[] = 0x80 | $codePoint       & 0x3F;
                break;
                
                case ($codePoint < 0x110000):

                    $bytes[] = 0xF0 | $codePoint >> 18;
                    $bytes[] = 0x80 | $codePoint >> 12 & 0x3F;
                    $bytes[] = 0x80 | $codePoint >> 6  & 0x3F;
                    $bytes[] = 0x80 | $codePoint       & 0x3F;
                break;
                
                default:
                    throw new standard_Utf8_Exception('Expected a valid code point.');
                break;
            }
            $result = call_user_func_array('pack', $bytes);
        }
        return $result;
    }

     // Compute the extended UTF-8 character of a given surrogate pair

    public static function utf8CharFromSurrogatePair($surrogatePair) 
    {
        list($upperSurrogate, $lowerSurrogate) = $surrogatePair;
        if (! (0xD800 <= $upperSurrogate && $upperSurrogate < 0xDC00))
        {
            throw new standard_Utf8_Exception('Expected an extended UTF-8 character.');
        }
        if (! (0xDC00 <= $lowerSurrogate && $lowerSurrogate < 0xE000))
        {
            throw new standard_Utf8_Exception('Expected an extended UTF-8 character.');
        }
        $codePoint = ($upperSurrogate & 0x03FF) << 10 | ($lowerSurrogate & 0x03FF);
        $codePoint += 0x10000;
        $result = self::utf8CharFromCodePoint($codePoint);
        
        return $result;
    }
    
    /**/
	
    private static function isCallable($handler)
    {
        $result = is_callable($handler['callback']) && is_array($handler['arguments']);
        return $result;
    }
    
    /**
     * A little calling interface: call
     * 
     * @param  array  $handler
     * @param  mixed  $args
     * @return mixed
     */
    private static function call($handler, $args)
    {
        $args = array_merge($handler['arguments'], is_array($args) ? $args : array($args));
        $result = call_user_func_array($handler['callback'], $args);
        return $result;
    }
    
    /**/
    protected static function validateFilters($options)
    {
        if (isset($options['filters']))
        {
            if (! is_array($options['filters']))
            {
                throw new standard_Utf8_Exception('Expected valid filters.');
            }
            foreach ($options['filters'] as $key => $value)
            {
                if (! self::isCallable($value))
                {
                    throw new standard_Utf8_Exception("Expected a valid $key handler.");
                }
            }
            return true;
        }
        return false;
    }
    
}

function full_utf8_options() 
{
	$result = array(
        'extendedUseSurrogate' => false,
        'write'                => array(
            'callback'  => create_function('$format, $unicode, $utf8Char', 'return $unicode < 0x10000 
            	? $utf8Char 
            	: sprintf($format, $unicode);'),
            'arguments' => array('(#%s#)'),
        ),
        'read'                 => array(
            'pattern'   => '\(#(\d+)#\)',
            'callback'  => create_function('$all, $unicode', 'return $unicode;'),
            'arguments' => array(),
        ),
        'filters'              => array(
            'before-write' => array(
                'callback'  => 'preg_replace',
                'arguments' => array('/\(#(\d+#\))/', '(##\1'),
            ),
            'after-read'   => array(
                'callback'  => 'preg_replace',
                'arguments' => array('/\(##(\d+#\))/', '(#\1'),
            ),
        ),
    );
	return $result;
}

function full_utf8_escape( $content ) 
{
	$options = full_utf8_options();
	try 
	{
	    $result = standard_Utf8::escape($content, $options);
	}
	catch (Exception $e)
	{
	    $result = $content;
	}
	return $result;
}

function full_utf8_search( $query_vars ) 
{
    $result = $query_vars;
	try 
	{
	    if (isset($query_vars['s']))
	    {
	        $options = full_utf8_options();
	        $result['s'] = standard_Utf8::escape($query_vars['s'], $options);
	    }
	}
	catch (Exception $e)
	{
	    $result = $query_vars;
	}
	return $result;
}

function full_utf8_unescape( $content ) 
{
	$options = full_utf8_options();
	try 
	{
	    $result = standard_Utf8::unescape($content, $options);
	}
	catch (Exception $e)
	{
	    $result = $content;
	}
	return $result;
}

/* Input Filters */
foreach (array(
    'title_save_pre',
    'excerpt_save_pre',
    'content_save_pre',
    
) as $full_utf8_filter)
{
    add_filter( $full_utf8_filter, 'full_utf8_escape', 10, 1 );
}
add_filter( 'request', 'full_utf8_search', 10, 1 );

/* Output Filters */
foreach (array(
    'title_edit_pre',   'the_title',   'the_title_rss',
    'excerpt_edit_pre', 'the_excerpt', 'the_excerpt_rss',
    'content_edit_pre', 'the_content', 'the_content_feed',
    
    'get_search_query',
    'wp_title',
    
) as $full_utf8_filter)
{
    add_filter( $full_utf8_filter, 'full_utf8_unescape', 10, 1 );
}

/* Strings Caption*/

function pw_gettext( $text ) {
	static $replace, $keys;

	if ( !is_array($replace) ) {
		$replace = array(

			'Widget' => 'ابزارک',
			'Widegts' => 'ابزارک',
			'Uopload/Insert' => 'بارگذاری/گذاشتن',
			'Unattached' => 'پیوست‌نشده',
			'Attached to' => 'پیوست به',
			'دسته‌جمعی' => 'گروهی',
			'تقویم' => 'ماه‌نگار',
			'برچسب‌ها' => 'آويزه‌ها',
			'Inactive' => 'غیرفعال',
			'All' => 'همه',
			'Update Available' => 'آماده بروزرسانی',
			'items' => 'مورد',
			'item' => 'مورد',
			'WordPress Blog' => 'وبگاه وردپرس',
			'Other WordPress News' => 'از دنیای وردپرس',
			'Spam' => 'هرزنامه',
			'Trash' => 'زباله‌دان',
			'Pending' => 'در انتظار بررسی',
			'with' => 'با',
			'Theme' => 'پوسته',
			'خصوصیات' => 'ویژگی‌ها',
			'جفنگ' => 'هرزنامه',
			'وردپرس فارسی' => 'وردپرس',
			'http://forum.wp-persian.com/forum/7' => 'http://wordpress.org/support/forum/requests-and-feedback',
			'http://forum.wp-persian.com' => 'http://wordpress.org/support',
			'http://wp-persian.com' => 'http://wordpress.org/',
			'http://codex.wp-persian.com' => 'http://codex.wordpress.org/',
			'حاشیه' => 'نوشتک',
			'فارسی' => 'پارسی',
			'صافی' => 'پالایه',
			'پروتکل' => 'درگاه',
			'شناسنامه' => 'نمایه',
			'ایمیل' => 'پست‌الکترونیک',
			'قوی' => 'مستحکم',
		);
		$keys = array_keys( $replace );
	}

	return str_replace( $keys, $replace, $text );
}

add_filter( 'gettext', 'pw_gettext' );
add_filter( 'gettext_with_context', 'pw_gettext' );
add_filter( 'ngettext', 'pw_gettext' );
add_filter( 'ngettext_with_context', 'pw_gettext' );


/* RTL n LTR buttons */

add_action( "init", "tinymce_bidi_addbuttons" );

function tinymce_bidi_addbuttons() {
	if( !current_user_can ( 'edit_posts' ) && !current_user_can ( 'edit_pages' ) ) {
		return;
	}
	if( get_user_option ( 'rich_editing' ) == 'true' ) {
		add_filter( "mce_external_plugins", "tinymce_bidi_plugin" );
		add_filter( "mce_buttons", "tinymce_bidi_buttons" );
	}
}
function tinymce_bidi_buttons($buttons) {
	array_push($buttons, "separator", "ltr", "rtl");
	return $buttons;
}

function tinymce_bidi_plugin($plugin_array) {
	$plugin_array['directionality'] = includes_url('js/tinymce/plugins/directionality/editor_plugin.js');

	return $plugin_array;
}

/* Persian Username */

function persian_world_user ($username, $raw_username, $strict)
{
	$username = wp_strip_all_tags ($raw_username);
	$username = remove_accents ($username);
	$username = preg_replace ('|%([a-fA-F0-9][a-fA-F0-9])|', '', $username);
	$username = preg_replace ('/&.+?;/', '', $username);
	if ($strict)
	{
		$settings = get_option ('pwusr_settings');
	}
	$username = trim ($username);
	$username = preg_replace ('|\s+|', ' ', $username);

	return $username;
}
add_filter ('sanitize_user', 'persian_world_user', 10, 3);

/* Tahoma for tinymce */
function persian_mce_css( $mce_css ) {
	if ( ! empty( $mce_css ) )
		$mce_css .= ',';

	$mce_css .= plugins_url( 'mce.css', __FILE__ );

	return $mce_css;
}

add_filter( 'mce_css', 'persian_mce_css' );
?>